# coding: utf-8
#  Copyright 2022 VMware, Inc.
#  SPDX-License-Identifier: Apache-2.0
from __future__ import absolute_import

from datetime import date
from datetime import datetime
from typing import Dict
from typing import List

from swagger_server import util
from swagger_server.models.base_model_ import Model


class ClusterConnectionInfo(Model):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    def __init__(
        self, user_name: str = None, password: str = None, host_name: str = None
    ):  # noqa: E501
        """ClusterConnectionInfo - a model defined in Swagger

        :param user_name: The user_name of this ClusterConnectionInfo.  # noqa: E501
        :type user_name: str
        :param password: The password of this ClusterConnectionInfo.  # noqa: E501
        :type password: str
        :param host_name: The host_name of this ClusterConnectionInfo.  # noqa: E501
        :type host_name: str
        """
        self.swagger_types = {"user_name": str, "password": str, "host_name": str}

        self.attribute_map = {
            "user_name": "userName",
            "password": "password",
            "host_name": "hostName",
        }
        self._user_name = user_name
        self._password = password
        self._host_name = host_name

    @classmethod
    def from_dict(cls, dikt) -> "ClusterConnectionInfo":
        """Returns the dict as a model

        :param dikt: A dict.
        :type: dict
        :return: The ClusterConnectionInfo of this ClusterConnectionInfo.  # noqa: E501
        :rtype: ClusterConnectionInfo
        """
        return util.deserialize_model(dikt, cls)

    @property
    def user_name(self) -> str:
        """Gets the user_name of this ClusterConnectionInfo.

        Represents the user name in the credential.  # noqa: E501

        :return: The user_name of this ClusterConnectionInfo.
        :rtype: str
        """
        return self._user_name

    @user_name.setter
    def user_name(self, user_name: str):
        """Sets the user_name of this ClusterConnectionInfo.

        Represents the user name in the credential.  # noqa: E501

        :param user_name: The user_name of this ClusterConnectionInfo.
        :type user_name: str
        """
        if user_name is None:
            raise ValueError(
                "Invalid value for `user_name`, must not be `None`"
            )  # noqa: E501

        self._user_name = user_name

    @property
    def password(self) -> str:
        """Gets the password of this ClusterConnectionInfo.

        Represents the password in the credential.  # noqa: E501

        :return: The password of this ClusterConnectionInfo.
        :rtype: str
        """
        return self._password

    @password.setter
    def password(self, password: str):
        """Sets the password of this ClusterConnectionInfo.

        Represents the password in the credential.  # noqa: E501

        :param password: The password of this ClusterConnectionInfo.
        :type password: str
        """

        self._password = password

    @property
    def host_name(self) -> str:
        """Gets the host_name of this ClusterConnectionInfo.

        Host name for connection to the VMware Aria Operations Cluster  # noqa: E501

        :return: The host_name of this ClusterConnectionInfo.
        :rtype: str
        """
        return self._host_name

    @host_name.setter
    def host_name(self, host_name: str):
        """Sets the host_name of this ClusterConnectionInfo.

        Host name for connection to the VMware Aria Operations Cluster  # noqa: E501

        :param host_name: The host_name of this ClusterConnectionInfo.
        :type host_name: str
        """
        if host_name is None:
            raise ValueError(
                "Invalid value for `host_name`, must not be `None`"
            )  # noqa: E501

        self._host_name = host_name
