# coding: utf-8
#  Copyright 2022 VMware, Inc.
#  SPDX-License-Identifier: Apache-2.0
from __future__ import absolute_import
from __future__ import annotations

from datetime import date
from datetime import datetime
from typing import Dict
from typing import List

from swagger_server import util
from swagger_server.models.attribute_definition import (
    AttributeDefinition,
)  # noqa: F401,E501
from swagger_server.models.base_model_ import Model


class GroupDefinition(Model):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    def __init__(
        self,
        attributes: List[AttributeDefinition] = None,
        groups: List[GroupDefinition] = None,
    ):  # noqa: E501
        """GroupDefinition - a model defined in Swagger

        :param attributes: The attributes of this GroupDefinition.  # noqa: E501
        :type attributes: List[AttributeDefinition]
        :param groups: The groups of this GroupDefinition.  # noqa: E501
        :type groups: List[GroupDefinition]
        """
        self.swagger_types = {
            "attributes": List[AttributeDefinition],
            "groups": List[GroupDefinition],
        }

        self.attribute_map = {"attributes": "attributes", "groups": "groups"}
        self._attributes = attributes
        self._groups = groups

    @classmethod
    def from_dict(cls, dikt) -> "GroupDefinition":
        """Returns the dict as a model

        :param dikt: A dict.
        :type: dict
        :return: The GroupDefinition of this GroupDefinition.  # noqa: E501
        :rtype: GroupDefinition
        """
        return util.deserialize_model(dikt, cls)

    @property
    def attributes(self) -> List[AttributeDefinition]:
        """Gets the attributes of this GroupDefinition.


        :return: The attributes of this GroupDefinition.
        :rtype: List[AttributeDefinition]
        """
        return self._attributes

    @attributes.setter
    def attributes(self, attributes: List[AttributeDefinition]):
        """Sets the attributes of this GroupDefinition.


        :param attributes: The attributes of this GroupDefinition.
        :type attributes: List[AttributeDefinition]
        """

        self._attributes = attributes

    @property
    def groups(self) -> List[GroupDefinition]:
        """Gets the groups of this GroupDefinition.


        :return: The groups of this GroupDefinition.
        :rtype: List[GroupDefinition]
        """
        return self._groups

    @groups.setter
    def groups(self, groups: List[GroupDefinition]):
        """Sets the groups of this GroupDefinition.


        :param groups: The groups of this GroupDefinition.
        :type groups: List[GroupDefinition]
        """

        self._groups = groups
